
% Default to the notebook output style

    


% Inherit from the specified cell style.




    
\documentclass[11pt]{article}

    
    
    \usepackage[T1]{fontenc}
    % Nicer default font (+ math font) than Computer Modern for most use cases
    \usepackage{mathpazo}

    % Basic figure setup, for now with no caption control since it's done
    % automatically by Pandoc (which extracts ![](path) syntax from Markdown).
    \usepackage{graphicx}
    % We will generate all images so they have a width \maxwidth. This means
    % that they will get their normal width if they fit onto the page, but
    % are scaled down if they would overflow the margins.
    \makeatletter
    \def\maxwidth{\ifdim\Gin@nat@width>\linewidth\linewidth
    \else\Gin@nat@width\fi}
    \makeatother
    \let\Oldincludegraphics\includegraphics
    % Set max figure width to be 80% of text width, for now hardcoded.
    \renewcommand{\includegraphics}[1]{\Oldincludegraphics[scale=1.15]{#1}}
    % Ensure that by default, figures have no caption (until we provide a
    % proper Figure object with a Caption API and a way to capture that
    % in the conversion process - todo).
    \usepackage{caption}
    \DeclareCaptionLabelFormat{nolabel}{}
    \captionsetup{labelformat=nolabel}

    \usepackage{adjustbox} % Used to constrain images to a maximum size 
    \usepackage{xcolor} % Allow colors to be defined
    \usepackage{enumerate} % Needed for markdown enumerations to work
    \usepackage{geometry} % Used to adjust the document margins
    \usepackage{amsmath} % Equations
    \usepackage{amssymb} % Equations
    \usepackage{textcomp} % defines textquotesingle
    % Hack from http://tex.stackexchange.com/a/47451/13684:
    \AtBeginDocument{%
        \def\PYZsq{\textquotesingle}% Upright quotes in Pygmentized code
    }
    \usepackage{upquote} % Upright quotes for verbatim code
    \usepackage{eurosym} % defines \euro
    \usepackage[mathletters]{ucs} % Extended unicode (utf-8) support
    \usepackage[utf8x]{inputenc} % Allow utf-8 characters in the tex document
    \usepackage{fancyvrb} % verbatim replacement that allows latex
    \usepackage{grffile} % extends the file name processing of package graphics 
                         % to support a larger range 
    % The hyperref package gives us a pdf with properly built
    % internal navigation ('pdf bookmarks' for the table of contents,
    % internal cross-reference links, web links for URLs, etc.)
    \usepackage{hyperref}
    \usepackage{longtable} % longtable support required by pandoc >1.10
    \usepackage{booktabs}  % table support for pandoc > 1.12.2
    \usepackage[inline]{enumitem} % IRkernel/repr support (it uses the enumerate* environment)
    \usepackage[normalem]{ulem} % ulem is needed to support strikethroughs (\sout)
                                % normalem makes italics be italics, not underlines
    

    
    
    % Colors for the hyperref package
    \definecolor{urlcolor}{rgb}{0,.145,.698}
    \definecolor{linkcolor}{rgb}{.71,0.21,0.01}
    \definecolor{citecolor}{rgb}{.12,.54,.11}

    % ANSI colors
    \definecolor{ansi-black}{HTML}{3E424D}
    \definecolor{ansi-black-intense}{HTML}{282C36}
    \definecolor{ansi-red}{HTML}{E75C58}
    \definecolor{ansi-red-intense}{HTML}{B22B31}
    \definecolor{ansi-green}{HTML}{00A250}
    \definecolor{ansi-green-intense}{HTML}{007427}
    \definecolor{ansi-yellow}{HTML}{DDB62B}
    \definecolor{ansi-yellow-intense}{HTML}{B27D12}
    \definecolor{ansi-blue}{HTML}{208FFB}
    \definecolor{ansi-blue-intense}{HTML}{0065CA}
    \definecolor{ansi-magenta}{HTML}{D160C4}
    \definecolor{ansi-magenta-intense}{HTML}{A03196}
    \definecolor{ansi-cyan}{HTML}{60C6C8}
    \definecolor{ansi-cyan-intense}{HTML}{258F8F}
    \definecolor{ansi-white}{HTML}{C5C1B4}
    \definecolor{ansi-white-intense}{HTML}{A1A6B2}

    % commands and environments needed by pandoc snippets
    % extracted from the output of `pandoc -s`
    \providecommand{\tightlist}{%
      \setlength{\itemsep}{0pt}\setlength{\parskip}{0pt}}
    \DefineVerbatimEnvironment{Highlighting}{Verbatim}{commandchars=\\\{\}}
    % Add ',fontsize=\small' for more characters per line
    \newenvironment{Shaded}{}{}
    \newcommand{\KeywordTok}[1]{\textcolor[rgb]{0.00,0.44,0.13}{\textbf{{#1}}}}
    \newcommand{\DataTypeTok}[1]{\textcolor[rgb]{0.56,0.13,0.00}{{#1}}}
    \newcommand{\DecValTok}[1]{\textcolor[rgb]{0.25,0.63,0.44}{{#1}}}
    \newcommand{\BaseNTok}[1]{\textcolor[rgb]{0.25,0.63,0.44}{{#1}}}
    \newcommand{\FloatTok}[1]{\textcolor[rgb]{0.25,0.63,0.44}{{#1}}}
    \newcommand{\CharTok}[1]{\textcolor[rgb]{0.25,0.44,0.63}{{#1}}}
    \newcommand{\StringTok}[1]{\textcolor[rgb]{0.25,0.44,0.63}{{#1}}}
    \newcommand{\CommentTok}[1]{\textcolor[rgb]{0.38,0.63,0.69}{\textit{{#1}}}}
    \newcommand{\OtherTok}[1]{\textcolor[rgb]{0.00,0.44,0.13}{{#1}}}
    \newcommand{\AlertTok}[1]{\textcolor[rgb]{1.00,0.00,0.00}{\textbf{{#1}}}}
    \newcommand{\FunctionTok}[1]{\textcolor[rgb]{0.02,0.16,0.49}{{#1}}}
    \newcommand{\RegionMarkerTok}[1]{{#1}}
    \newcommand{\ErrorTok}[1]{\textcolor[rgb]{1.00,0.00,0.00}{\textbf{{#1}}}}
    \newcommand{\NormalTok}[1]{{#1}}
    
    % Additional commands for more recent versions of Pandoc
    \newcommand{\ConstantTok}[1]{\textcolor[rgb]{0.53,0.00,0.00}{{#1}}}
    \newcommand{\SpecialCharTok}[1]{\textcolor[rgb]{0.25,0.44,0.63}{{#1}}}
    \newcommand{\VerbatimStringTok}[1]{\textcolor[rgb]{0.25,0.44,0.63}{{#1}}}
    \newcommand{\SpecialStringTok}[1]{\textcolor[rgb]{0.73,0.40,0.53}{{#1}}}
    \newcommand{\ImportTok}[1]{{#1}}
    \newcommand{\DocumentationTok}[1]{\textcolor[rgb]{0.73,0.13,0.13}{\textit{{#1}}}}
    \newcommand{\AnnotationTok}[1]{\textcolor[rgb]{0.38,0.63,0.69}{\textbf{\textit{{#1}}}}}
    \newcommand{\CommentVarTok}[1]{\textcolor[rgb]{0.38,0.63,0.69}{\textbf{\textit{{#1}}}}}
    \newcommand{\VariableTok}[1]{\textcolor[rgb]{0.10,0.09,0.49}{{#1}}}
    \newcommand{\ControlFlowTok}[1]{\textcolor[rgb]{0.00,0.44,0.13}{\textbf{{#1}}}}
    \newcommand{\OperatorTok}[1]{\textcolor[rgb]{0.40,0.40,0.40}{{#1}}}
    \newcommand{\BuiltInTok}[1]{{#1}}
    \newcommand{\ExtensionTok}[1]{{#1}}
    \newcommand{\PreprocessorTok}[1]{\textcolor[rgb]{0.74,0.48,0.00}{{#1}}}
    \newcommand{\AttributeTok}[1]{\textcolor[rgb]{0.49,0.56,0.16}{{#1}}}
    \newcommand{\InformationTok}[1]{\textcolor[rgb]{0.38,0.63,0.69}{\textbf{\textit{{#1}}}}}
    \newcommand{\WarningTok}[1]{\textcolor[rgb]{0.38,0.63,0.69}{\textbf{\textit{{#1}}}}}
    
    
    % Define a nice break command that doesn't care if a line doesn't already
    % exist.
    \def\br{\hspace*{\fill} \\* }
    % Math Jax compatability definitions
    \def\gt{>}
    \def\lt{<}
    % Document parameters
    \title{Universal-Turing-machine}
    \author{Jim Hef{}feron}
    \date{2022-Jan-29}
    
    
    

    % Pygments definitions
    
\makeatletter
\def\PY@reset{\let\PY@it=\relax \let\PY@bf=\relax%
    \let\PY@ul=\relax \let\PY@tc=\relax%
    \let\PY@bc=\relax \let\PY@ff=\relax}
\def\PY@tok#1{\csname PY@tok@#1\endcsname}
\def\PY@toks#1+{\ifx\relax#1\empty\else%
    \PY@tok{#1}\expandafter\PY@toks\fi}
\def\PY@do#1{\PY@bc{\PY@tc{\PY@ul{%
    \PY@it{\PY@bf{\PY@ff{#1}}}}}}}
\def\PY#1#2{\PY@reset\PY@toks#1+\relax+\PY@do{#2}}

\expandafter\def\csname PY@tok@w\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.73,0.73}{##1}}}
\expandafter\def\csname PY@tok@c\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}
\expandafter\def\csname PY@tok@cp\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.74,0.48,0.00}{##1}}}
\expandafter\def\csname PY@tok@k\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@kp\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@kt\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.69,0.00,0.25}{##1}}}
\expandafter\def\csname PY@tok@o\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@ow\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.67,0.13,1.00}{##1}}}
\expandafter\def\csname PY@tok@nb\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@nf\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,1.00}{##1}}}
\expandafter\def\csname PY@tok@nc\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,1.00}{##1}}}
\expandafter\def\csname PY@tok@nn\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,1.00}{##1}}}
\expandafter\def\csname PY@tok@ne\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.82,0.25,0.23}{##1}}}
\expandafter\def\csname PY@tok@nv\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@no\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.53,0.00,0.00}{##1}}}
\expandafter\def\csname PY@tok@nl\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.63,0.63,0.00}{##1}}}
\expandafter\def\csname PY@tok@ni\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.60,0.60,0.60}{##1}}}
\expandafter\def\csname PY@tok@na\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.49,0.56,0.16}{##1}}}
\expandafter\def\csname PY@tok@nt\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@nd\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.67,0.13,1.00}{##1}}}
\expandafter\def\csname PY@tok@s\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@sd\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@si\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.73,0.40,0.53}{##1}}}
\expandafter\def\csname PY@tok@se\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.73,0.40,0.13}{##1}}}
\expandafter\def\csname PY@tok@sr\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.40,0.53}{##1}}}
\expandafter\def\csname PY@tok@ss\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@sx\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@m\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@gh\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,0.50}{##1}}}
\expandafter\def\csname PY@tok@gu\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.50,0.00,0.50}{##1}}}
\expandafter\def\csname PY@tok@gd\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.63,0.00,0.00}{##1}}}
\expandafter\def\csname PY@tok@gi\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.63,0.00}{##1}}}
\expandafter\def\csname PY@tok@gr\endcsname{\def\PY@tc##1{\textcolor[rgb]{1.00,0.00,0.00}{##1}}}
\expandafter\def\csname PY@tok@ge\endcsname{\let\PY@it=\textit}
\expandafter\def\csname PY@tok@gs\endcsname{\let\PY@bf=\textbf}
\expandafter\def\csname PY@tok@gp\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,0.50}{##1}}}
\expandafter\def\csname PY@tok@go\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.53,0.53,0.53}{##1}}}
\expandafter\def\csname PY@tok@gt\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.27,0.87}{##1}}}
\expandafter\def\csname PY@tok@err\endcsname{\def\PY@bc##1{\setlength{\fboxsep}{0pt}\fcolorbox[rgb]{1.00,0.00,0.00}{1,1,1}{\strut ##1}}}
\expandafter\def\csname PY@tok@kc\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@kd\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@kn\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@kr\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@bp\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@fm\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,1.00}{##1}}}
\expandafter\def\csname PY@tok@vc\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@vg\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@vi\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@vm\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@sa\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@sb\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@sc\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@dl\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@s2\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@sh\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@s1\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@mb\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@mf\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@mh\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@mi\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@il\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@mo\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@ch\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}
\expandafter\def\csname PY@tok@cm\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}
\expandafter\def\csname PY@tok@cpf\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}
\expandafter\def\csname PY@tok@c1\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}
\expandafter\def\csname PY@tok@cs\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}

\def\PYZbs{\char`\\}
\def\PYZus{\char`\_}
\def\PYZob{\char`\{}
\def\PYZcb{\char`\}}
\def\PYZca{\char`\^}
\def\PYZam{\char`\&}
\def\PYZlt{\char`\<}
\def\PYZgt{\char`\>}
\def\PYZsh{\char`\#}
\def\PYZpc{\char`\%}
\def\PYZdl{\char`\$}
\def\PYZhy{\char`\-}
\def\PYZsq{\char`\'}
\def\PYZdq{\char`\"}
\def\PYZti{\char`\~}
% for compatibility with earlier versions
\def\PYZat{@}
\def\PYZlb{[}
\def\PYZrb{]}
\makeatother


    % Exact colors from NB
    \definecolor{incolor}{rgb}{0.0, 0.0, 0.5}
    \definecolor{outcolor}{rgb}{0.545, 0.0, 0.0}



    
    % Prevent overflowing lines due to hard-to-break entities
    \sloppy 
    % Setup hyperref package
    \hypersetup{
      breaklinks=true,  % so long urls are correctly broken across lines
      colorlinks=true,
      urlcolor=urlcolor,
      linkcolor=linkcolor,
      citecolor=citecolor,
      }
    % Slightly bigger margins than the latex defaults
    
    \geometry{verbose,tmargin=1in,bmargin=1in,lmargin=1in,rmargin=1in}
    
    

    \begin{document}
    
    
    \maketitle
    
    

    
    \section{Universal Turing machine}\label{universal-turing-machine}

We will sketch how to construct a universal Turing machine, \(U\).

Programming a reasonably large Turing machine involves a number of tasks
that are tedious, with fiddly details. We will try to strike a balance:
to say enough that it will be perfectly clear that these tasks can be
done, while also avoiding laying out the full collection of four-tuples,
which is counterproductive.

We have boiled the job of writing \(U\) down to five tasks (this
approach is based on a document by Jason Teutsch.). Where writing a
Turing machine is writing machine code, these five tasks are like macros
for the assembler. They are a somewhat higher-level description of what
their consituent instruction sequences are doing.

We will first describe the input to \(U\). Then we will sketch how \(U\)
works, except that we will only sketch the five tasks, and leave
producing the four-tuples as exercises.

    \subsection{\texorpdfstring{The input to
\(U\)}{The input to U}}\label{the-input-to-u}

We are given the tape containing the number of the machine
\(\mathcal{M}\). Immediately to the right is a marker, \(Z\) (see
below), and after that is the machine's input.

\begin{center}
\includegraphics{asy/utm0.pdf} 
\end{center}

We take the encoding, both of the Turing
machine and of the tape characters, to be as in the prior lab. In
particular, we represent integers or characters in unary, as strings of
\(1\)'s.

    \subsubsection{Markers}\label{markers}

The lab on encoding Turing machines uses the alphabet \(\{B,1\}\). But
here we will use \emph{markers}, such as \(Z\), or \(X\), or \(Y\) (our
convention is to use capital letters, and to stay away from \(B\)).

As we saw in the encoding lab, we often need to separate information on
the tape. In that lab, we used single blanks to separate the parts of a
four-tuple instruction, and also used pairs of blanks to separate
four-tuples. Here we need some more separators.

We can imagine that \(Z\) stands for a 5-tuple of blanks, and that other
markers stand for other sequences. (We must arrange that there is no
possibility of confusing, say, a \(Z\) followed by another \(Z\) for a
ten-blank marker.) But another option is to instead think of it as
having enlarged the alphabet of \(U\) to allow new characters. This is
very convenient, both for readability here and also because it means,
for instance, that we can just put \(Z\) in an instruction and don't
have to write lots of four-tuples to work through strings of five
blanks. In short, we will take the universal machine to have the
alphabet \(\Sigma=\{B,1,G,H,\ldots Z\}\).

    \subsection{\texorpdfstring{Sketch of \(U\)'s
action}{Sketch of U's action}}\label{sketch-of-us-action}

The action of \(U\) in computing the effect of the machine \(M\) is very
much like the Racket program from an earlier lab that simulates a given
Turing machine. At its heart, \(U\) iterates \(M\)'s Delta function.

    \subsubsection{Set up a buffer}\label{set-up-a-buffer}

Before \(U\) begins the simulation, it does a bit of bookkeeping.
Remember that the representation of \(M\) is really just a list of
four-tuples. We shall use this list to compute the values of \(M\)'s
Delta function.

For that computation, to the left of marker \(Y\), we set aside a region
of tape as a \emph{buffer} to hold the inputs to Delta, that is, to hold
the present state and present symbol. 

\begin{center}
\includegraphics{asy/utm1.pdf}
\end{center}

\noindent 
This buffer must be wide enough to hold the number of the largest state
and the largest number representing a symbol, along with a separator
between them. We mark the left of the buffer with \(X\).

So, one of the five tasks at the end of this document, task 3, explains
how to search through the representation of \(M\) and find the largest
state number or largest character representation.

    \subsubsection{Represent the tape}\label{represent-the-tape}

The universal machine \(U\) must simulate the tape of \(M\) that is
infinite in both directions. We will divide \(M\)'s tape cells into two
groups: the cells to the left of the initial position of \(M\)'s
read/write head, and the cells to the right, along with the one under
the head. The machine \(U\) simulates the cells to the left using the
tape region to the left of the marker \(X\). And \(U\) simulates the the
cell under the intial position along with those to the right by using
the tape region to the right of the marker \(Z\).

\begin{center}
\includegraphics{asy/utm3.pdf}
\end{center}

    \subsubsection{Iterate the Delta
function}\label{iterate-the-delta-function}

Now the universal machine \(U\) ready for the the simulation of the
given machine \(M\). Here are the steps.

\begin{enumerate}
\def\labelenumi{\arabic{enumi}.}
\setcounter{enumi}{-1}
\item
  The present state is \(0\), and the present character is the one
  represented to the right of \(Z\). Put these two unary numbers, the
  state number and the representation number, into the buffer and
  separate them with a blank. This requires copying a contiguous
  sequence of \(1\)'s from one place on the tape to another; this is
  Task 1 below.
\item
  Find \(M\)'s four-tuple with the state, character pair matching what
  is in the buffer. Searching inside the machine for a match is Task 2
  below.
\item
  If the next action is \texttt{L} or \texttt{R} then move the simulated
  head, as in Task 4. Otherwise, copy the next state and next character
  into the buffer, and return to step 1. Doing an if-then is Task 2.
\end{enumerate}

    \subsection{Five tasks}\label{five-tasks}

To run the simulation we will need five tasks, which we can think of as
macros for an assembler, or as routines in a simple programming
language. As sketched above, these are things that \(U\) will use in the
course of simulating \(M\).

These are arranged from easiest to hardest, rather than in the order
they are encountered earlier. This is because experience with easier
tasks is a big help with doing later ones.

Each task is described in italics. After this statement of requirements
is a sketch of one possible approach. (You can ignore the state numbers
in the sketch pictures; they are only the ones that happen to appear in
one version of the machine.)

    \subsubsection{Task1: copying}\label{task1-copying}

The universal machine needs to copy numbers from place to place. For
instance, it needs to copy the next state into the buffer.

We show how to copy using markers \(S\) and \(T\). This exercise asks
for a machine that copies from the left to the right, but a similar
machine copies from right to left (with the added assumption that the
space between the two markers is large enough to hold the source
number).

\paragraph{Exercise}\label{exercise}

\emph{Begin with the tape containing markers \(S\) and \(T\), with \(T\)
to the right of \(S\). In the interval between the two are strokes and
blanks, but the tape is blank to the right of \(T\). Start with the
read/write head of \(U\) pointing to \(S\).}

\begin{center}
\includegraphics{asy/copy0.pdf} 
\end{center}

\emph{Write a Turing machine, a set of
four-tuples, that finishes with the interval unchanged, but also with
the number immediately after \(S\) (that is, the number of contiguous
\(1\)'s to the right of \(S\) with no intervening blanks) copied just to
the right of \(T\). End with the head pointing to \(S\).}

Here is a sketch of one way to proceed. From the starting setup, move
right and replace the \(1\) with a \(G\), then move past \(T\) and put a
\(1\) there. 

\begin{center}
\includegraphics{asy/copy1.pdf} 
\end{center}

\noindent Now iterate. Return to
\(S\), slide past the existing \(G\)'s, replace the \(1\) that
immediately follows with another \(G\), and then move past \(T\) along
with any subsequent \(1\)'s, and put down a new \(1\).

\begin{center}
\includegraphics{asy/copy2.pdf} 
\end{center}

\noindent
When the iteration in the prior sentence
goes to the end of the \(G\)'s and finds a \(B\), return to the starting
\(S\) and change the \(G\)'s to \(1\)'s. 

\begin{center}
\includegraphics{asy/copy3.pdf}
\end{center}

    \subsubsection{Task 2: matching}\label{task-2-matching}

The universal machine \(U\) needs to match the current state and current
symbol with the four-tuple instructions stored in the description of
\(M\). Then it can fetch the next state and the next action.

\paragraph{Exercise}\label{exercise}

\emph{Let \(S\) and \(T\) be markers, with \(S\) to the left of \(T\),
and the other characters on the tape are only blanks and \(1\)'s. Start
with the read/write head of the machine on the marker \(S\).}

\begin{center}
\includegraphics{asy/match0.pdf} 
\end{center}

\noindent
\emph{Write a Turing machine that ends in
state \(q_{100}\) if the number of \(1\)'s immediately following \(S\)
equals the number of \(1\)'s immediately following \(T\), that is, if
\(x_s=x_t\). If the number of \(1\)'s don't match then the machine ends
in state \(q_{101}\). The machine should end with the tape exactly the
same as when it started, and with the head pointing to marker \(S\).}

One way to proceed is to start at \(S\) and for each \(1\), rewrite it
as a \(G\). Then scan right past \(T\) to find the matching \(1\) and
rewrite it as an \(H\). 

\begin{center}
\includegraphics{asy/match1.pdf} 
\end{center}

\noindent
Iterate this
until one or the other sequence of \(1\)'s runs out. Here we show the
case where the \(1\)'s after \(S\) are the first to run out.

\begin{center}
\includegraphics{asy/match2.pdf} 
\end{center}

\noindent
In this case we scan right to find
whether the \(1\)'s after \(T\) have run out at the same time.

\begin{center}
\includegraphics{asy/match3.pdf} 
\end{center}

\noindent
In this example they have run out at
the same time, so \(x_s=x_t\). Change the \(G\)'s and \(H\)'s back to
\(1\)'s, reposition the head at \(S\), and go to state \(q_{100}\).

\begin{center}
\includegraphics{asy/match4.pdf}
\end{center}

    \subsubsection{Task 3: establish the
buffer}\label{task-3-establish-the-buffer}

We need to leave enough space to hold the largest number that we find.
(Actually, we must leave room for the largest state and also room for
the largest character representation. But here we will just do the
single largest number in the interval.)

\paragraph{Exercise}\label{exercise}

\emph{Begin with the tape having markers \(S\) and \(T\), with \(T\) to
the right of \(S\). In the interval between the two are strokes and
blanks, but the tape is blank to the left of \(S\) as well as to the
right of \(T\). Start with the head pointing at \(S\).}

\begin{center}
\includegraphics{asy/findmax0.pdf} 
\end{center}

\noindent
\emph{Write a Turing machine that
finishes with the interval unchanged, and with a copy of the largest
number from that interval just to \(S\)'s left.}

One way to proceed is to move right from \(S\), find the first number,
and replace \(1\)'s with \(H\)'s. 

\begin{center}
\includegraphics{asy/findmax1.pdf} 
\end{center}

\noindent
For
each such replacement, move left from \(S\) and put \(G\)'s over what is
there. 

\begin{center}
\includegraphics{asy/findmax2.pdf} 
\end{center}

\noindent
At the end of the first number
to \(S\)'s right, change the blank to a \(J\).

\begin{center}
\includegraphics{asy/findmax3.pdf} 
\end{center}

\noindent
Then go back and turn the \(G\)'s to
\(1\)'s. 

\begin{center}
\includegraphics{asy/findmax4.pdf}
\end{center}

Now iterate the prior steps. The reason to use \(G\)'s instead of
directly using \(1\)'s becomes clear; we can see that the second number
to \(S\)'s right is smaller than the first because the \(G\)'s sit
inside the \(1\)'s from the prior iteration.

\begin{center}
\includegraphics{asy/findmax5.pdf}
\end{center}

\noindent
This is the picture when we are done. 

\begin{center}
\includegraphics{asy/findmax6.pdf}
\end{center}

    \subsubsection{Task 4: move the simulated
head}\label{task-4-move-the-simulated-head}

For \(U\) to simulate \(M\), it must simulate tape moves. Here we show
how \(U\) can slide past the character represented under \(M\)'s head,
that is, the first sequence of \(1\)'s to the right of \(Z\).

\paragraph{Exercise}\label{exercise}

\emph{Begin with a tape containing the markers \(S\) and \(T\), with
\(S\) to the left of \(T\). All other symbols on the tape are blanks and
\(1\)'s. To the right of \(T\) is a blank, then a sequence of \(1\)'s,
and then another blank (possibly the sequence of \(1\)'s is empty). Call
the sequence of \(1\)'s the "representation under \(U\)'s head". Here it
is marked \(x\).}

\begin{center}
\includegraphics{asy/move0.pdf} 
\end{center}

\noindent
\emph{Write a Turing machine
that moves the representation under \(U\)'s head to the left of \(S\).
That is, when the machine finishes the the initial blank and the
sequence of \(1\)'s is no longer to the right of \(T\). Instead, to the
left of \(S\) the machine has inserted a sequence of the same number of
\(1\)'s, separated from \(S\) by a blank. In terms of the above picture,
when the code is finished then \texttt{11} should be to the left of
\(S\), and no longer to the right of \(T\).}

You could proceed by first sliding right to \(T\), and overwriting the
blank that is there. 

\begin{center}
\includegraphics{asy/move1.pdf} 
\end{center}

\noindent
Then we move the
other things in the interval to the right, or what is the same thing,
carrying the blank down until it is just to the left of \(S\)

\begin{center}
\includegraphics{asy/move2.pdf}
\end{center}

The next step is the critical one. Slide down to \(T\) again. The are
two cases. If on \(T\)'s right is a blank then the character represented
on \(M\)'s tape is a blank. Finish by carrying it down to the left of
\(S\).

The other case is that the character to the right of \(T\) is a \(1\).
In this case we carry each such \(1\) down to the left of \(S\),

\begin{center}
\includegraphics{asy/move3.pdf} 
\end{center}

\noindent
and repeating until all the \(1\)'s are
moved, that is, until the next character to the right of \(T\) is a
blank. 

\begin{center}
\includegraphics{asy/move4.pdf}
\end{center}

    \subsubsection{Task 5: substitution}\label{task-5-substitution}

Let \(S\) and \(T\) be markers, with \(S\) to the left of \(T\), and
only blanks and \(1\)'s between. Start with the head of \(U\) on the
marker \(S\).

Let \(I\) be a sequence of unary representations, that is, sequences of
\(1\)'s, separated by single blanks. Suppose that \(I\) lies immediately
to the right of \(T\). Suppose also that there is a single unary
representation, with \(k\)-many \(1\)'s, to the immediate right of
\(S\).

\begin{center}
\includegraphics{asy/sub0.pdf}
\end{center}

Then there is a set of Turing four-tuples that replaces the first term
in \(I\), its first unary representation, with \(k\)-many \(1\)'s.

\begin{center}
\includegraphics{asy/utm6.pdf}
\end{center}

Note that in replacing three \(1\)'s with two, the machine must close
up, so that \(I\) is one shorter.

\paragraph{Exercise}\label{exercise}

\emph{Let \(S\) and \(T\) be markers, with \(S\) to the left of \(T\),
and only blanks and \(1\)'s between. Start with the head of \(U\) on the
marker \(S\). To the right of \(S\) is a sequence of \(k\)-many \(1\)'s.
To the right of \(T\) let there be an interval of unary representations,
that is, sequences of \(1\)'s, separated by single blanks. In the
drawing below the interval is broken in two, with the initial sequence
labeled \(I_0\). Suppose also that there is a single unary
representation, with \(k\)-many \(1\)'s, to the immediate right of
\(S\).}

\begin{center}
\includegraphics{asy/sub0.pdf} 
\end{center}

\noindent
\emph{Write a Turing machine that ends
with the sequence \(I_0\) replaced with \(k\)-many \(1\)'s.}

You can proceed in this way.
First, as in Task 4, move the $1$'s immediately to the right 
of $T$ to be immediately to the right of $W$.

\begin{center}
\includegraphics{asy/sub1.pdf}
\end{center}

That is, replace the blank between $I_0$ and $I_1$ with a marker $R$, and then as in Task 4 move the interval between $R$ and $W$ down, sliding $I_0$ up past $W$.
Finally, replace $R$ with a blank.

Then, blank out the $1$'s to the right of $W$.

\begin{center}
\includegraphics{asy/sub2.pdf}
\end{center}

We have collapsed the interval between $T$ and $W$ to have one fewer argument. 

Next, copy $k$ past $W$.

\begin{center}
\includegraphics{asy/sub3.pdf}
\end{center}

To finish, move $k$ next to $T$.
That is, put a marker, $R$, to the immediate right of $T$,

\begin{center}
\includegraphics{asy/sub4.pdf}
\end{center}

and move the interval from $R$ to $T$ past the upper $k$.

\begin{center}
\includegraphics{asy/sub5.pdf}
\end{center}

    % Add a bibliography block to the postdoc
    
    
    
    \end{document}
